﻿
package{
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.Point;
	
	public class Pixel
	{
		private var _x:Number;
		private var _y:Number;
		private var _ix:Number;
		private var _iy:Number;
		private var _fx:int;
		private var _fy:int;
		private var _c:uint;
		private var _activo:Boolean = false;
		private var _recolectar:Boolean = false;
		private var _salto:Number = Math.random()*40 + 4;
		
		
		public function Pixel(x:Number,y:Number,fx:int,fy:int,c:uint)
		{
			_x = x;
			_y = y;
			_ix = x;
			_iy = y;
			_fx = fx;
			_fy = fy;
			_c = c;
		}
		
		public function mover():void 
		{
			_x += (_fx - _x) / _salto;
			_y += (_fy - _y) / _salto;
			
			var d:Number = Point.distance(new Point(_fx, _fy), new Point(_x, _y));
			if (d < 1) evOnComplete();
		}
		
		private function evOnComplete():void 
		{
			_x = _fx;
			_y = _fy;
			_activo = false;
			_recolectar = true;
		}
		
		// GETTERS/SETTERS
		public function get x():Number { return _x;	}
		public function get y():Number { return _y;	}
		public function get ix():Number { return _ix; }
		public function get iy():Number { return _iy; }
		public function get c():uint { return _c;	}
		public function get activo():Boolean { return _activo; }
		public function set activo(b:Boolean):void { _activo = b }
		public function get recolectar():Boolean { return _recolectar; }
		
	}
}