﻿package 
{
	import flash.display.*;
	import flash.filters.*;
	import flash.geom.*;
	import flash.events.*;
	
	public class MascaraAlpha extends MovieClip
	{
		// MCs en el escenario
		public var mancha_mc:MovieClip;
		public var imagen_mc:MovieClip;
		
		private var _bitmap:Bitmap = new Bitmap();
		private var _bmpData:BitmapData = new BitmapData(600, 410, true, 0);
		private var _noiseMap:BitmapData;
		private var _tempMap:BitmapData;
		private var _point:Point = new Point();
		private var _displace:DisplacementMapFilter;
			
		
		function MascaraAlpha():void {
			init();
		}
		
		private function init():void
		{
			mancha_mc.visible = false;
			imagen_mc.visible = false;
			
			// Efecto
			_noiseMap = _bmpData.clone();
			_tempMap = _bmpData.clone();
			_displace = new DisplacementMapFilter( _noiseMap, _point, 1, 2, 12, 12, DisplacementMapFilterMode.COLOR, 0, 0);
			
			_bmpData.draw(mancha_mc);
			_bitmap.bitmapData = _bmpData;
			addChild(_bitmap);
			
			imagen_mc.visible = true;
			generarMascara();
			
			// Eventos
			this.stage.addEventListener(MouseEvent.CLICK, go);
		}
		
		private function motor(e:Event):void 
		{
			_noiseMap.perlinNoise(10, 8, 2, Math.random() * 100, false, true, 7, false, null);
			_tempMap.applyFilter( _bmpData, _bmpData.rect, _point, _displace );
			_bmpData.draw( _tempMap, null, null, BlendMode.MULTIPLY);
		}
		
		private function go(e:MouseEvent):void 
		{
			this.addEventListener(Event.ENTER_FRAME, motor);
		}
		
		private function generarMascara():void
		{
			// Máscara mask //
			/*imagen_mc.cacheAsBitmap = true;
			_bitmap.cacheAsBitmap = true;
			imagen_mc.mask = _bitmap;*/
			
			// Máscara alpha //
			var contenedor:Sprite = new Sprite();
			addChild(contenedor);
			contenedor.addChild(imagen_mc);
			contenedor.addChild(_bitmap);
			contenedor.blendMode = BlendMode.LAYER;
			_bitmap.blendMode = BlendMode.ALPHA;
		}
	}
}