﻿
package
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.text.*;
	import flash.utils.Timer;
	import flash.utils.getDefinitionByName;
	
	public class Main extends MovieClip
	{	
		
		private var _texto:String = "subflash";
		
		private var _bmpDataFuente:BitmapData = new BitmapData(200, 70, false, 0);
		private var _bmpFuente:Bitmap = new Bitmap(_bmpDataFuente);
		
		private var _bmpDataDestino:BitmapData = new BitmapData(200, 70, false, 0);
		private var _bmpDestino:Bitmap = new Bitmap(_bmpDataDestino);
		private var _pixels:Array = new Array();
		
		private var _contenedorMotivos:Sprite = new Sprite();
		private var cont:int = 0;
		
		
		public function Main() {
			init();
		}
		
		private function init():void 
		{
			var fuente:Font = new FontGiddyup();
			var formato:TextFormat = new TextFormat(fuente.fontName, 70);
			formato.letterSpacing = 3;
			
			var txt:TextField = new TextField();
			txt.text = _texto;
			txt.autoSize = TextFieldAutoSize.LEFT;
			txt.textColor = 0xFFFFffff;
			txt.setTextFormat(formato);
			txt.embedFonts = true;
			txt.antiAliasType = AntiAliasType.ADVANCED;
			txt.x = 10;
			txt.y = 10;
			addChild(txt);
						
			// Bitmap Fuente
			_bmpDataFuente.draw(txt);
			_bmpFuente.x = 10;
			_bmpFuente.y = 80;
						
			// Bitmap Destino
			_bmpDestino.x = 10;
			_bmpDestino.y = 160;
			
			_contenedorMotivos.x = 10;
			_contenedorMotivos.y = 200;
			
			parsearImagen();
			pintarPalabra();
			
			addChild(_bmpFuente);
			addChild(_bmpDestino);
			addChild(_contenedorMotivos);
		}
		
		private function parsearImagen():void 
		{
			var sw:int = _bmpDataFuente.width;
			var sh:int = _bmpDataFuente.height;
			var c:uint;
			
			for(var sy=0; sy < sh; sy++ )
			{
				for(var sx=0; sx < sw; sx++)
				{				
					// Obtener color de cada pixel
					c = _bmpDataFuente.getPixel32(sx, sy);
					
					// Con embed fonts, formato 32 bits
					if (c != 0xFF000000)
					{
						// Porcentaje
						if (int(Math.random() < .7))
						{	
							_pixels.push(new Point(sx, sy));
							_bmpDataDestino.setPixel32(sx, sy, 0xFFffff00);
						}						
					}
					else {
						
						//_bmpDataDestino.setPixel32(sx,sy,0xFFff00FF);
					}
				}
			}
			trace("Num pixels:",_pixels.length);
		}
		
		private function pintarPalabra():void
		{
			for (var a:String in _pixels) 
			{
				var rd:int = int(Math.random()*3) + 4;
				var Clase:Class = getDefinitionByName("MCPegatina" + rd) as Class;
								
				var m:Sprite = new Clase();
				m.scaleX = m.scaleY = Math.random()*(.04 -.03) +.03;
				//m.scaleX = m.scaleY = 0.1;
												
				var p:Point = _pixels[a];
				m.x = p.x;
				m.y = p.y;
				_contenedorMotivos.addChild(m);
			}
			
			_contenedorMotivos.scaleX = _contenedorMotivos.scaleY = 5;
		}		
	}
}