﻿
package
{
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import flash.utils.Timer;
	import flash.system.System;
	import flash.system.Capabilities;
	
	public class FPS extends Sprite
	{
		private var _txt:TextField;
		private var _fps:int = 0;
		
		public function FPS()
		{
			init();
		}
		
		private function init():void 
		{
			// Fondo
			var fondo:Shape = new Shape();
			fondo.graphics.beginFill(0x006699, .5);
			fondo.graphics.drawRect(0, 0, 60, 18);
			fondo.graphics.endFill();
			addChild(fondo);
			
			// Texto
			_txt = new TextField();
			_txt.height = 16;
			_txt.width = 240;
			_txt.x = 5;
			_txt.defaultTextFormat = new TextFormat("Verdana", 10, 0XFFFFFF);
			_txt.text = _fps.toString();
			addChild(_txt);
			
			// Timer
			var t:Timer = new Timer(1000);
			t.addEventListener(TimerEvent.TIMER, secundero);
			t.start();
			
			// Eventos
			addEventListener(Event.ENTER_FRAME, updateFrame);
		}
		
		private function secundero(e:TimerEvent):void 
		{
			// Muestra los FPS
			//_txt.text = Capabilities.version +  " // FPS " + _fps.toString() + " // MB " + Math.round(System.totalMemory/1048576);
			_txt.text = "FPS " + _fps.toString();
			_fps = 0;
		}
		
		private function updateFrame(e:Event):void 
		{
			_fps++;
		}
	}
}