﻿
package
{
	import flash.display.*;
	import flash.events.*;
	import com.bit101.components.CheckBox;
	
	public class Main extends MovieClip
	{
		private var checkTrama:CheckBox;
		private var checkOverlay:CheckBox;
		private var checkAlpha:CheckBox;
		
		private var _bitmapData:BitmapData;
		private var _trama:Sprite;
		
		private var _colorNegro:uint = 0xFF000000;
		
		
		public function Main(){
			init();
		}
		
		public function init():void
		{
			// Pattern Data
			_bitmapData = new BitmapData(3, 4, true, 0);
			_bitmapData.setPixel32(0, 0, _colorNegro);
			_bitmapData.setPixel32(1, 1, _colorNegro);
			_bitmapData.setPixel32(2, 2, _colorNegro);
			_bitmapData.setPixel32(1, 3, _colorNegro);
						
			_trama = new Sprite();
			addChild(_trama);
			
			drawTrama();
			
			// Componentes
			checkTrama = new CheckBox(this, 20, 484, "Trama", clickTrama);
			checkTrama.selected = true;
			this.addChild(checkTrama);
						
			checkAlpha = new CheckBox(this, 80, 484, "Alpha", clickAlpha);
			checkAlpha.selected = true;
			_trama.alpha = .4
			this.addChild(checkAlpha);
						
			checkOverlay = new CheckBox(this, 140, 484, "Overlay", clickOverlay);
			checkOverlay.selected = true;
			_trama.blendMode = BlendMode.OVERLAY;
			this.addChild(checkOverlay);
		}
		
		private function drawTrama():void
		{
			var sw:int = stage.stageWidth;
			var sh:int = stage.stageHeight -20;
			
			with (_trama.graphics) {
				clear();
				beginBitmapFill(_bitmapData, null, true);
				lineTo(sw, 0);
				lineTo(sw, sh);
				lineTo(0, sh);				
				endFill();
			}
		}
		
		// Handlers Componentes
		private function clickTrama(e:MouseEvent):void {
			_trama.visible = e.target.selected;
		}
		
		private function clickAlpha(e:MouseEvent):void 
		{
			if (e.target.selected) _trama.alpha = .4
			else _trama.alpha = 1;
		}
		
		private function clickOverlay(e:MouseEvent):void 
		{
			if (e.target.selected) _trama.blendMode = BlendMode.OVERLAY
			else _trama.blendMode = BlendMode.NORMAL;
		}
	}
}